/**
* $isFluid: no mobile o container é fluido ou contido na grid.
* $container--max-width: largura maxima do container, ao qual será acrescentado o valor da margem esq e dir.
*
* fluid-viewport-breakpoint: largura minima apartir da qual o padding passa a aumentar, aplicado quando "$isFluid: true"
*
* $margin--TB-unset: sem margem top e bottom
*
* $margin--T-m: margin-top em mobile
* $margin--B-m: margin-bottom em mobile
* $margin--T-d: margin-top em desktop
* $margin--B-d: margin-bottom em desktop
*
* $margin--LR-m: padding-left e padding-right em mobile
* $margin--LR-d: padding-left e padding-right em desktop
*/

@mixin mixin-container(
  $is-fluid: false,
  $container--max-width: $viewport--content-width,
  $fluid-viewport-breakpoint: $viewport--mobile-max-width,

  $margin--TB-unset: false,
  $margin--T-m: $margin--TB-mobile,
  $margin--T-d: $margin--TB-desktop,
  $margin--B-m: $margin--TB-mobile,
  $margin--B-d: $margin--TB-desktop,

  $margin--LR-m: $margin--LR-mobile,
  $margin--LR-d: $margin--LR-desktop
) {
  // define a largura maxima do conteudo
  // soma a largura total o tamanho maximo das margens laterais.
  $max-width: calc(#{$container--max-width} + (#{$margin--LR-d} * 2));

  // define o valor minimo da margem lateral
  // $is-fluid o valor minimo é 0
  // senão o valor é igual a variavel $margin--LR-m
  $margin--LR: if($is-fluid, 0, $margin--LR-m);

  width: min(100%, $max-width);

  // remove a margem top e bottom
  @if $margin--TB-unset {
    margin: 0 auto;
  } @else {
    margin: {
      top: fluid-type($margin--T-m, $margin--T-d);
      right: auto;
      bottom: fluid-type($margin--B-m, $margin--B-d);
      left: auto;
    }
  }

  @if $is-fluid {
    padding: 0
      fluid-type($margin--LR, $margin--LR-d, $fluid-viewport-breakpoint);
  } @else {
    padding: 0 fluid-type($margin--LR, $margin--LR-d);
  }
}
